package de.intevation.flys.model;

import java.io.Serializable;
import java.util.List;
import java.math.BigDecimal;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import org.hibernate.Session;
import org.hibernate.Query;
import org.hibernate.annotations.Type;

import com.vividsolutions.jts.geom.Geometry;


import de.intevation.flys.backend.SessionHolder;

@Entity
@Table(name = "hws_points")
public class HWSPoint implements Serializable {

    private Integer    id;

    private Integer    ogr_fid;
    private HWSKind    kind;
    private FedState  fedState;
    private River     river;
    private Integer   offical;
    private Integer   shore_side;
    private String    name;
    private String    path;
    private String    agency;
    private String    range;
    private String    source;
    private String    status_date;
    private String    description;
    private BigDecimal    freeboard;
    private BigDecimal    dike_km;
    private BigDecimal    z;
    private BigDecimal    z_target;
    private BigDecimal    rated_level;
    private Geometry     geom;

    @Id
    @Column(name = "id")
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }


    @Column(name = "geom")
    @Type(type = "org.hibernatespatial.GeometryUserType")
    public Geometry getGeom() {
        return geom;
    }


    public void setGeom(Geometry geom) {
        this.geom = geom;
    }

    /**
     * Get ogr_fid.
     *
     * @return ogr_fid as Integer.
     */
    @Column(name = "ogr_fid")
    public Integer getOgrFid()
    {
        return ogr_fid;
    }

    /**
     * Set ogr_fid.
     *
     * @param ogr_fid the value to set.
     */
    public void setOgrFid(Integer ogr_fid)
    {
        this.ogr_fid = ogr_fid;
    }


    /**
     * Get offical.
     *
     * @return offical as Integer.
     */
    @Column(name = "offical")
    public Integer getOffical()
    {
        return offical;
    }

    /**
     * Set offical.
     *
     * @param offical the value to set.
     */
    public void setOffical(Integer offical)
    {
        this.offical = offical;
    }

    /**
     * Get shore_side.
     *
     * @return shore_side as Integer.
     */
    @Column(name = "shore_side")
    public Integer getShoreSide()
    {
        return shore_side;
    }

    /**
     * Set shore_side.
     *
     * @param shore_side the value to set.
     */
    public void setShoreSide(Integer shore_side)
    {
        this.shore_side = shore_side;
    }

    /**
     * Get name.
     *
     * @return name as String.
     */
    @Column(name = "name")
    public String getName()
    {
        return name;
    }

    /**
     * Set name.
     *
     * @param name the value to set.
     */
    public void setName(String name)
    {
        this.name = name;
    }

    /**
     * Get path.
     *
     * @return path as String.
     */
    @Column(name = "path")
    public String getPath()
    {
        return path;
    }

    /**
     * Set path.
     *
     * @param path the value to set.
     */
    public void setPath(String path)
    {
        this.path = path;
    }

    /**
     * Get agency.
     *
     * @return agency as String.
     */
    @Column(name = "agency")
    public String getAgency()
    {
        return agency;
    }

    /**
     * Set agency.
     *
     * @param agency the value to set.
     */
    public void setAgency(String agency)
    {
        this.agency = agency;
    }

    /**
     * Get range.
     *
     * @return range as String.
     */
    @Column(name = "range")
    public String getRange()
    {
        return range;
    }

    /**
     * Set range.
     *
     * @param range the value to set.
     */
    public void setRange(String range)
    {
        this.range = range;
    }

    /**
     * Get source.
     *
     * @return source as String.
     */
    @Column(name = "source")
    public String getSource()
    {
        return source;
    }

    /**
     * Set source.
     *
     * @param source the value to set.
     */
    public void setSource(String source)
    {
        this.source = source;
    }

    /**
     * Get status_date.
     *
     * @return status_date as String.
     */
    @Column(name = "status_date")
    public String getStatusDate()
    {
        return status_date;
    }

    /**
     * Set status_date.
     *
     * @param status_date the value to set.
     */
    public void setStatusDate(String status_date)
    {
        this.status_date = status_date;
    }

    /**
     * Get description.
     *
     * @return description as String.
     */
    @Column(name = "description")
    public String getDescription()
    {
        return description;
    }

    /**
     * Set description.
     *
     * @param description the value to set.
     */
    public void setDescription(String description)
    {
        this.description = description;
    }

    /**
     * Get freeboard.
     *
     * @return freeboard as BigDecimal.
     */
    @Column(name = "freeboard")
    public BigDecimal getFreeboard()
    {
        return freeboard;
    }

    /**
     * Set freeboard.
     *
     * @param freeboard the value to set.
     */
    public void setFreeboard(BigDecimal freeboard)
    {
        this.freeboard = freeboard;
    }

    /**
     * Get dike_km.
     *
     * @return dike_km as BigDecimal.
     */
    @Column(name = "dike_km")
    public BigDecimal getDike_km()
    {
        return dike_km;
    }

    /**
     * Set dike_km.
     *
     * @param dike_km the value to set.
     */
    public void setDike_km(BigDecimal dike_km)
    {
        this.dike_km = dike_km;
    }

    /**
     * Get z.
     *
     * @return z as BigDecimal.
     */
    @Column(name = "z")
    public BigDecimal getZ()
    {
        return z;
    }

    /**
     * Set z.
     *
     * @param z the value to set.
     */
    public void setZ(BigDecimal z)
    {
        this.z = z;
    }

    /**
     * Get z_target.
     *
     * @return z_target as BigDecimal.
     */
    @Column(name = "z_target")
    public BigDecimal getZTarget()
    {
        return z_target;
    }

    /**
     * Set z_target.
     *
     * @param z_target the value to set.
     */
    public void setZTarget(BigDecimal z_target)
    {
        this.z_target = z_target;
    }

    /**
     * Get rated_level.
     *
     * @return rated_level as BigDecimal.
     */
    @Column(name = "rated_level")
    public BigDecimal getRatedLevel()
    {
        return rated_level;
    }

    /**
     * Set rated_level.
     *
     * @param rated_level the value to set.
     */
    public void setRatedLevel(BigDecimal rated_level)
    {
        this.rated_level = rated_level;
    }

    /**
     * Get kind.
     *
     * @return kind as HWSKind.
     */
    @OneToOne
    @JoinColumn(name = "kind_id")
    public HWSKind getKind()
    {
        return kind;
    }

    /**
     * Set kind.
     *
     * @param kind the value to set.
     */
    public void setKind(HWSKind kind)
    {
        this.kind = kind;
    }

    /**
     * Get fedState.
     *
     * @return fedState as FedState.
     */
    @OneToOne
    @JoinColumn(name = "fed_state_id")
    public FedState getFedState()
    {
        return fedState;
    }

    /**
     * Set fedState.
     *
     * @param fedState the value to set.
     */
    public void setFedState(FedState fedState)
    {
        this.fedState = fedState;
    }

    /**
     * Get river.
     *
     * @return river as River.
     */
    @OneToOne
    @JoinColumn(name = "river_id")
    public River getRiver()
    {
        return river;
    }

    /**
     * Set river.
     *
     * @param river the value to set.
     */
    public void setRiver(River river)
    {
        this.river = river;
    }
}

